<template>
  <q-toolbar class="bg-primary text-white raised" role="region" aria-label="Lijst header">
    <q-toolbar-title role="heading" aria-level="2">Definition link
      <q-badge outline align="top" v-if="hypercubes_filtered">
        {{ hypercubes_filtered.length }}
      </q-badge>
      <q-badge outline align="top" v-else>0</q-badge>
    </q-toolbar-title>
  </q-toolbar>
  <q-card>
    <q-card-section>
      <q-input label="filter" v-model="search_value" tabindex="0" title="Filter lijst" autofocus>
        <template v-slot:prepend>
          <q-icon name="filter_alt"/>
        </template>
      </q-input>
    </q-card-section>
  </q-card>

  <q-list bordered class="scroll_list" :key="language_switch" role="region" aria-label="Lijst van definitions">
    <q-item clickable v-ripple
            v-for="(hypercube, index) in hypercubes_filtered"
            v-bind:id="hypercube.hc_role_uri"
            v-bind:key="index"
            active-class="active"
            :dts_name="dts_name"
            tabindex="0"
            title="klik voor details"
            :to="{name: 'hypercube_detail', params: {hc_role_uri: hypercube.hc_role_uri.replaceAll('/','|'), nt_version: this.nt_version}}">
      <q-item-section>
        <q-item-label v-html="show_label(hypercube)"></q-item-label>
      </q-item-section>
    </q-item>
    <q-inner-loading :showing="typeof this.hypercubes=='undefined'">
      <q-circular-progress
        class="text-blue-grey"
        indeterminate
        size="50px"
        :thickness="0.22"
        v-if="typeof this.hypercubes=='undefined'"></q-circular-progress>
    </q-inner-loading>

  </q-list>

</template>

<script>
import {api} from 'boot/axios'
import _ from 'lodash'
import SharedMethods from "components/SharedMethods";

export default {
  name: "DefinitionLinkList",
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
    this.fetchData()
  },
  data() {
    return {
      hypercubes: undefined,
      current_hypercube: Object,
      search_value: '',
      language_switch: undefined
    }
  },
  props: {
    dts_name: String,
    nt_version: String
  },
  watch: {
    "$route.query.lang": function () {
      this.language_switch = this.$route.query.lang
    }
  },
  methods: {
    fetchData: function () {
      api
        .get("/dts/" + this.dts_name + "/hypercubes",
          {params: {nt_version: this.nt_version, full: 0}})
        .then(response => {
          this.hypercubes = response.data
          if (this.hypercubes.length && this.$route.fullPath.endsWith('definition')) {
            this.$router.push({
              name: 'hypercube_detail',
              replace: true,
              params: {hc_role_uri: this.hypercubes[0].hc_role_uri.replaceAll('/', '|')}
            })
          } else {
            this.$nextTick(() => {
              this.scroll_to_active()
            })
          }
        })
        .catch((error) => {
          this.hypercubes = []
        })

    },
    scroll_to_active: function () {
      let activelist = document.getElementsByClassName('active')
      if (activelist.length) {
        let el = activelist[0]
        let offset = el.getBoundingClientRect().top - window.scrollY - 100
        if (offset > window.innerHeight || offset < 0) {
          this.$nextTick(() => {
              el.scrollIntoView(true)
            }
          )
        }
      }
    }
  },
  computed: {
    hypercubes_filtered() {
      if (!_.isUndefined(this.search_value) && this.search_value.length > 1) {
        return this.hypercubes.filter(hypercube => hypercube.definition &&
          hypercube.definition.toLowerCase().includes(this.search_value.toLowerCase()))
      } else {
        return this.hypercubes
      }
    }
  }

}
</script>

<style scoped lang="scss">
.active {
  background: $primary;
  color: white;
  opacity: 0.9;
}

.scroll_list {
  overflow-y: auto;
  height: calc(100vh - 290px);
}

</style>
